// Author: George W. Taylor
// http://www.tropicalcoder.com/
// Date: 15 Oct 2012
// License: Creative Commons - Non-Commercial Use

#pragma once
#include "MFTP.h"

class Server : public MFTP
{
public:
	Server(CRCFunction crcFunc, LoggingFunction logFunc, UDPSendFunction udpSendFunc, UDPReceiveFunction udpReceiveFunc)
		: MFTP(crcFunc, logFunc, udpSendFunc, udpReceiveFunc) {}

	bool receiveFile(std::string& filename, std::vector<uint8_t>& file_data);

private:
	void sendAckMessage(uint32_t blocknum, uint32_t crc32);
	uint32_t file_size_bytes_recd = 0;
};