// Author: George W. Taylor
// http://www.tropicalcoder.com/
// Date: 25 May 2024
// License: This work is licensed under Creative Commons Attribution-ShareAlike 4.0 International 
// (CC BY-SA 4.0). https://creativecommons.org/licenses/by-sa/4.0/

// Class UDP_Send
#include "UDP_Send.h"
#include <ws2tcpip.h>
#include <string>
#include <iostream>


UDP_Send::UDP_Send(PCSTR address, u_short port)
{
	// Create a socket
	udpSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if (udpSocket == INVALID_SOCKET)
	{
		std::cerr << "Socket creation failed with error: " << WSAGetLastError() << std::endl;
		WSACleanup();
		return;
	}

	// Set up the sockaddr_in structure
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(port);
	serverAddr.sin_addr.s_addr = inet_addr(address);
	// inet_pton(AF_INET, address, &serverAddr.sin_addr);
}


UDP_Send::~UDP_Send()
{
	WSACleanup();
}

void UDP_Send::exampleUDPSendFunction(const std::vector<uint8_t>& data)
{
	// Send the data
	auto result = sendto(udpSocket, reinterpret_cast<const char*>(data.data()), data.size(), 0, reinterpret_cast<sockaddr*>(&serverAddr), sizeof(serverAddr));
	if (result == SOCKET_ERROR)
	{
		std::cerr << "Send failed with error: " << WSAGetLastError() << std::endl;
	}

}